class Formator

  def self.format_sequence(sequence:, options: {array: nil, offset: nil})
    if options[:array] && !options[:offset]
      return convert_to_array(sequence)
    end

    if options[:array] && options[:offset]
      return offset(convert_to_array(sequence), options[:offset])
    end

    if options[:offset] && !options[:array]
      return offset(sequence, options[:offset])
    end

    return sequence
  end

  private

  def self.convert_to_array(sequence)
    array = []
    sequence.length.times { |element| array[element] = sequence[element].to_i }
    array
  end

  def self.offset(sequence, offset)
    if sequence.is_a?(String)
      return offset_array(sequence.split(//), offset).join
    end
    return offset_array(sequence, offset)
  end

  def self.offset_array(array, offset)
    offset.times { array << array.shift }
    return array
  end

end
